%% Demo: Generalized Total Variation Denoising 
% Ddenoising of discontinuous piecewise linear signal

%% Start

clear

%% Make test signal

N = 100;                    % N : signal length
n = 0:N-1;

n2 = 1:N/2;
s = [n2 -0.2*n2]'/(N/2);    % s : Test signal

rng('default')
rng(1);                     % Set state for reproducibility

w = 0.15 * randn(N, 1);     % w : zero-mean Gaussian noise

y = s + w;                  % y : noisy signal


%% Run algorithm

Nit = 50;                   % Nit : number of iterations
rho1 = 10;
rho2 = 0.5;
[x, u, cost] = gtvd(y, rho1, rho2, Nit);

figure(1)
clf

subplot(2, 1, 1)
plot(cost)
xlabel('Iteration')
title('Cost function history')

subplot(2, 1, 2)
plot(n, y, n, x)
legend('Noisy', 'Denoised')
title('Generalized TV Denoising')

print -dpdf demo_fig1


